package zero1hd.polyjet.entity.boxes;

import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.utils.Array;
import com.badlogic.gdx.utils.Pool;

import zero1hd.polyjet.entity.Entities;
import zero1hd.polyjet.entity.Entity;
import zero1hd.polyjet.entity.enemies.VoidCircle;

public class BoxOfEnemies {
	private final Array<Entity> ActiveEnemies;
	
	private final Pool<VoidCircle> voidCirclePool;
	
	public BoxOfEnemies(final ShapeRenderer shapeRenderer) {
		ActiveEnemies = new Array<Entity>();
		
		voidCirclePool = new Pool<VoidCircle>() {
			@Override
			protected VoidCircle newObject() {
				return new VoidCircle(shapeRenderer);
			}
		};
	}
	
	public Entity getEntity(Entities entity) {
		switch (entity) {
		case VOID_CIRCLE:
			VoidCircle voidCircle = voidCirclePool.obtain();
			ActiveEnemies.add(voidCircle);
			return voidCircle;
		case BAR_BEAT:
			return null;
		case SHARDS:
			return null;
		default:
			return null;
		}
	}
	
	public void free(Entity entity, Entities type) {
		switch (type) {
		case BAR_BEAT:
			break;
		case SHARDS:
			break;
		case VOID_CIRCLE:
			ActiveEnemies.removeValue(entity, true);
			voidCirclePool.free((VoidCircle) entity);
			break;
		default:
			break;
		
		}
	}
}
